Main Page | Modules | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | Related Pages

# SoLight Class Reference
[Nodes]

`#include <Inventor/nodes/SoLight.h>`

Inheritance diagram for SoLight:

List of all members.

## Detailed Description

The SoLight class is the base class for light emitting nodes.

This node type is abstract and does not in itself provide any light sources to the scene, you need to use one of its subclasses.

There are a few important things to know about light sources in Coin. First of all, the more light sources you have in your scene, the slower the rendering will be. The impact on rendering speed is highly dependent on the graphics hardware and/or rendering subsystem software implementation (i.e. how optimized an OpenGL you or your users are running), but it could be severe.

Another issue which is important to know is that OpenGL rendering engines usually have a fixed maximum number of available light sources which can be present in the state at the same time. If you reach the maximum number, further light sources will simply be ignored. The maximum number of light sources for OpenGL rendering can be found by using:

          #include <Inventor/elements/SoGLLightIdElement.h>
    #include <Inventor/nodes/SoSubNodeP.h>
          // ...[snip]...
          int nrlights = SoGLLightIdElement::getMaxGLSources();

If you are clever with how you use light sources, you can get away with using a lot more lights in a scene graph than the max available from the rendering system. This is because light sources are stacked on the traversal state, just like other appearance data. So if you put light sources under SoSeparator nodes, they will be popped off and "forgotten" for the remaining geometry of the scene graph after the subgraph below an SoSeparator has been traversed.

## Public Member Functions
virtual void | callback (SoCallbackAction *action)
## Static Public Member Functions
void | initClass (void)
## Public Attributes
SoSFBool | on
SoSFFloat | intensity
SoSFColor | color
## Protected Member Functions
| SoLight (void)
virtual | ~SoLight ()

## Constructor & Destructor Documentation

SoLight::SoLight | ( | void |  | ) | `[protected]`

| Constructor.

SoLight::~SoLight | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoLight::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoNode. Reimplemented in SoDirectionalLightManip, SoPointLightManip, SoSpotLightManip, SoDirectionalLight, SoPointLight, and SoSpotLight.

void SoLight::callback | ( | SoCallbackAction * | action | ) | `[virtual]`

| Action method for SoCallbackAction. Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph. Reimplemented from SoNode. Reimplemented in SoDirectionalLightManip, SoPointLightManip, and SoSpotLightManip.

## Member Data Documentation

SoSFBool SoLight::on

| Whether light source should be on or off. The on-flag defaults to `TRUE`.

SoSFFloat SoLight::intensity

| Intensity of light source. This decides how much the light source should affect the colors etc of the scene geometry. Valid range is 0.0 (none) to 1.0 (maximum). Default value is 1.0.

SoSFColor SoLight::color

| Color of light source. Default is an all-white light source.

The documentation for this class was generated from the following files:

- SoLight.h
- SoLight.cpp